<?php
function ingestXMLFile($pid, $path){
	$protocol = "http"; 
	$host = "localhost"; 
	$port = 8080; 
	$context = "fedora"; 

	$fedoraUserPwd = "fedoraAdmin:fedoraAdmin"; // username:password 
	$fedoraVerifyPeer = false; // false for ignoring self signed certificates 

	
	$xml = file_get_contents($path); 

	 
	$queryArgs = array("label" => "Foxml metadata", 
			 "format" => "info:fedora/fedora-system:FOXML-1.1", 
			 "encoding" => "UTF-8", 
			 "namespace" => "my_prfefix", 
			 "ownerID" => "fedoraAdmin", 
			 "logMessage" => "ingest"); 

	// generate URL, encoding query string 
	$url = sprintf("%s://%s:%d/%s/objects/%s?%s", 
			 $protocol, 
			 $host, 
			 $port, 
			 $context, 
			 $pid, 
			 http_build_query($queryArgs)); 

	// for getting Fedora to recognise the POST content 
	$headers = array("Accept: text/xml", "Content-Type: text/xml"); 

	$curl_opts = array(CURLOPT_RETURNTRANSFER => true, 
			 CURLOPT_URL => $url, 
			 CURLOPT_HTTPHEADER => $headers, 
			 CURLOPT_USERPWD => $fedoraUserPwd, 
			 CURLOPT_HTTPAUTH => CURLAUTH_BASIC, 
			 CURLOPT_SSL_VERIFYPEER => $fedoraVerifyPeer, 
			 CURLOPT_POST => true, 
			 CURLOPT_POSTFIELDS => $xml); 

	$ch = curl_init(); 
	curl_setopt_array($ch, $curl_opts); 
	$pid =  curl_exec($ch); // get new PID returned 

	//echo $pid . "</br>"; 
}

?>