<?php
session_start();
if(!isset($_SESSION['username'])){
 header("Location:index.html");
 exit();
}
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Ingestion</title>

    <!-- Bootstrap -->
    <link href="css/bootstrap.min.css" rel="stylesheet">
	<script src="js/jquery-1.11.1.min.js"></script>	
	<script src="js/bootstrap.min.js"></script>
	<script src="js/checkall.js"></script>
	<script src="js/jquery.validate.min.js"></script>
	
  </head>
  <body>
	  <div class="navbar navbar-inverse navbar-fixed-top" role="navigation">
		  <div class="container">
			<div class="navbar-header">
			  <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target=".navbar-collapse">
				<span class="sr-only">Toggle navigation</span>
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			  </button>
			  <a class="navbar-brand" style="color: #FFBA02;">Zamani Archive Backend</a>
			</div>
			<div class="collapse navbar-collapse">
			  <ul class="nav navbar-nav">
				<li ><a href="download_management.php">Download Management</a></li>
				<li class="dropdown">
					<a href="#" class="dropdown-toggle" data-toggle="dropdown">Metadata Management<span class="caret"></span></a>
					<ul class="dropdown-menu" role="menu" style="background-color: #101010;">
					<li><a href="metaTool/Meta-fy.php" target="_blank" style="color: #777;">Meta-fy<img style="float:right;" src="Images/external_link.png"></a></li>
					<li class="divider"></li>
					<li><a href="metaTool/java_docs/index.html"  target="_blank" style="color: #777;">Java Docs<img style="float:right;" src="Images/external_link.png"></a></li>
					</ul>
				</li>
				<li class="active"><a href="ingestion.php">Ingestion</a></li>
				<li><a href="login/logout.php">Logout</a></li>
			  </ul>
			</div><!--/.nav-collapse -->
		  </div>
		</div>
		
		<div class="container">
			<div class="col-lg-3" style="border-bottom-right-radius: 4px;  border-bottom-left-radius: 4px;">
				<div class="container-fluid">
					<span class="list-group-item" style="background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold; width=100%;">Control Panel</span>
					<button id="ingest_button" class="btn btn-default" style="margin-top: 20px;width: 100%; background-color:#333333; color:#fff;"> Ingest</button>
					<button id="purge_button" class="btn btn-default" style="margin-top: 20px;width: 100%; background-color:#aea79f;color:#fff;"> Purge</button>
				</div>
			</div>	
			
			<div class="col-lg-9" id="IngestForm">
				<div class="container-fluid">
					<ul class="list-group">
						<li class="list-group-item" style="background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold; ">Ingest Metadata</li>
						<div style="margin-top:15px;">
						<form id="ingest"  action="ingest/upload.php" method="post" enctype="multipart/form-data">
							<label>Parent Collection:<input type="text" id="collection" name="collection" required="required"/></label>
							<label style="margin-left:15px;">Site:<input type="text" id="site" name="site" required="required"/></label>
							<label class="btn btn-default" style="margin-top:15px;"><input  type="file" id="file" name="files[]" multiple="multiple" accept="application/xml" required="required"/></label>
							<input class="btn btn-default" style="margin-top:15px;" type="submit" value="Ingest" />
						</form>
						</div>
					</ul>
				</div>
			</div>
			
		
			<div class="col-lg-9" id="PurgeForm" style="display:none;">
				<div class="container-fluid">
					<ul class="list-group">
					<li class="list-group-item" style="background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;">Purge Metadata</li>
						<div style="margin-top:15px;">
						<form id="purge" name="purge" >
							<?php	
							$collections = glob('uploads/*/*', GLOB_ONLYDIR);
							echo "<select id='selected_collection' name='selected_collection'>";
							foreach ($collections as $collection) {
								echo "<option value='".$collection."'>".$collection."</option>"; 
							}
							echo "</select>";
							?>		
							<button class="btn btn-default" type="submit" value="purgeSite">Purge Collection</button>
						</form>
						</div>
						
						<div style="margin-top:15px;">
						<form id="purge_pids" name="purge_pids" >
							<input type="text" id="pids" name="pids" required="required"/>
							<button class="btn btn-default" type="submit" >Purge PID(S)</button>
						</form>
						<label style="font-style:italic; margin-top:15px;border: 1px solid gray;border-radius: 3px; padding: 6px; font-size: 12px; font-weight: 100;">Example: uctnew:0000099 OR uctnew:0000099,uctnew:0000099 </label>
						</div>
					</ul>	
					<div><h4>Console:</h4></div>
					<div id="purge_console" style="overflow-y:auto; height:325px;"></div>
				</div>
			</div>
		</div>
 
    
	<script type="text/javascript">
		
	$("#ingest_button").click(function(){
			$("#PurgeForm").hide();
			$("#purge_button").css("background-color", "#aea79f");
			$("#ingest_button").css("background-color", "#333333");
			$("#ingest_button").css("color", "#fff");	
			$("#IngestForm").show();
			return false;
	});
	
	$("#purge_button").click(function(){
			$("#IngestForm").hide();
			$("#ingest_button").css("background-color", "#aea79f");
			$("#purge_button").css("background-color", "#333333");
			$("#purge_button").css("color", "#fff");
			$("#PurgeForm").show();
			return false;
	});
	
	$(document).ready(function (){
		$("#ingest").validate();
		
		$("form").each(function(){
				$(this).validate({
				submitHandler: function (form) { 
					if(form["name"]=="purge"){
					purge();
					}
					if(form["name"]=="purge_pids"){
					purgePids();
					}
					}
				}); 
			}); 	
	});
	
	
	
	function purge(){
		var dataString = {selected_collection:$("#selected_collection").val()};
		$.ajax({
					type:"POST",
					url:"purge/purger.php",
					data: dataString,
					cache: false,
					success: function(html){
						$("#purge_console").append(html);
					}
				});
		
	}
	
	function purgePids(){
		var dataString = {pids:$("#pids").val()};
		$.ajax({
					type:"POST",
					url:"purge/purger.php",
					data: dataString,
					cache: false,
					success: function(html){
						$("#purge_console").append(html);
					}
				});
		
	}
	
	
	</script>
</body>
</html>	