
// Truncate long urls with string.trunc(length)
String.prototype.trunc = String.prototype.trunc || function(n){
  return this.length> n ? this.substr(0,n-1)+'&hellip;' : this;
};

function getQueryVariable(variable)
{
       var query = window.location.search.substring(1);
       var vars = query.split("&");
       for (var i=0;i<vars.length;i++) {
            var pair = vars[i].split("=");
            if(pair[0] == variable){return pair[1];}
       }
       return(false);
}

function getSelectedFacets()
{
	var selectedFacets=new Array();
	var count = 0;

	$('.list-group-item input:checkbox').each(function () {
		if (this.checked){
			selectedFacets[count] = $(this).val();
			count++;
		}
	});
	return selectedFacets;
}

function toggleInfo(docNumber) {

	var currentClassOfDocumentDetails = document.getElementById("documentDetails:"+docNumber).className;
	var currentClassOfDocumentDetailsLong = document.getElementById("documentDetailsLong:"+docNumber).className;

	if (currentClassOfDocumentDetails == "show"){
		document.getElementById("documentDetails:"+docNumber).className = "hide";
		document.getElementById("documentDetailsLong:"+docNumber).className = "show";
	}
	else{
		document.getElementById("documentDetails:"+docNumber).className = "show";
		document.getElementById("documentDetailsLong:"+docNumber).className = "hide";
	}
}

function mvPrint(arrayorstring) {
	if (typeof arrayorstring == 'string') {
		arrayorstring = [arrayorstring]
	}
	if (typeof arrayorstring == 'undefined') {
		return 'undefined'
	}
	return arrayorstring.join(', ')
}

function strip(html)
{
   var tmp = document.createElement("DIV");
   tmp.innerHTML = html;
   return tmp.textContent || tmp.innerText || "";
}

function sanitize(s) {
	return s;
}

function replacestrongs(s) {
	return s.replace(/&lt;strong&gt;/g, '<strong>').replace(/&lt;\/strong&gt;/g, '</strong>')
}

function correctidlink(sa) {

	if (typeof sa == 'string') {
		sa = [sa]
	}
	if (typeof sa == 'undefined') {
		return '#'
	}
	return sa[0];
}

function populateAndInsertMap(){
	var map;

	var siteCount = 0;
	
	mapCenter = new google.maps.LatLng(-0.137712, 8.675520);
	
	var mapOptions = {
		zoom: 3,
		center: mapCenter
	}
	map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
	
	// Start by getting all members of the root (Zamani Collection)
	var query = "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/risearch.php?type=tuples&lang=itql&format=json&query=select%20%24member%20from%20%3C%23ri%3E%20where%20%24member%20%3Cfedora-rels-ext:isMemberOf%3E%20%3Cinfo:fedora/zamaniProjectCollection:1%3E";	
	//console.log(query);
	$.get(query, function(data,status){
		// Get array of results
		var dataArray = data.results;
		
		for (i=0;i<dataArray.length;i++)
		{
			//Country Collection PID
			var countryColPID = dataArray[i].member;
			// Then get the members (Site/s) of the returned Zamani Collection members (Country)
			var query = "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/risearch.php?type=tuples&lang=itql&format=json&query=select%20%24member%20from%20%3C%23ri%3E%20where%20%24member%20%3Cfedora-rels-ext:isMemberOf%3E%20%3C"+countryColPID+"%3E";	
			//console.log(query);
			$.get(query, function(data,status){

				var siteDataArray = data.results;
				for (i=0;i<siteDataArray.length;i++)
				{
					var siteColFedoraObject = siteDataArray[i].member;
					var siteColPID = siteColFedoraObject.split("/")[1];
					
					// Now get the Site Datastreams metadata	
						
					var queryObjectMIMEDatastream = "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?"+siteColPID+"/datastreams/SITE/content";	
					console.log(queryObjectMIMEDatastream);
					$.get(queryObjectMIMEDatastream, function(data,status){
						var country = data.getElementsByTagName("country")[0].childNodes[0].nodeValue;
						var siteName = data.getElementsByTagName("name")[0].childNodes[0].nodeValue;
						var latitude = data.getElementsByTagName("latitude")[0].childNodes[0].nodeValue;
						var longitude = data.getElementsByTagName("longitude")[0].childNodes[0].nodeValue;
						
						var marker = new google.maps.Marker({
							position: new google.maps.LatLng(latitude, longitude),
							map: map,
							title: siteName 
						});

						google.maps.event.addListener(marker,'click',function(j) { return function() { onMarkerClick(j+''); }; }(siteColPID));
						siteCount++;
					});
				}
			});
		}
	});
}

function createCollectionMap(collectionCanvasId, siteColPID, latitude, longitude, siteName){
	var map;

	var siteCount = 0;
	
	mapCenter = new google.maps.LatLng(latitude, longitude);
	
	var mapOptions = {
		zoom: 3,
		center: mapCenter,
		disableDefaultUI: true
	}
	map = new google.maps.Map(document.getElementById(collectionCanvasId), mapOptions);

	var marker = new google.maps.Marker({
		position: new google.maps.LatLng(latitude, longitude),
		map: map,
		title: siteName 
	});

	google.maps.event.addListener(marker,'click',function(j) { return function() { onMarkerClick(j+''); }; }(siteColPID));
}


function escapedPID(pid){
	var pidHalved = pid.split(":");
	var pidEscaped = pidHalved[0]+"\\:"+pidHalved[1];
	return pidEscaped;
}

function onMarkerClick(sitePID) {
	var sitePIDEscaped = escapedPID(sitePID);
	var q = 'RELS_EXT_isMemberOf_uri_s:info\\:fedora/'+ sitePIDEscaped;
	//$('#selectedCollectionQuery').val(q);
	//appendFacetsAndPaginatedSearchResults(q);
	//$('#map-canvas').hide();
	window.location = "http://nala.cs.uct.ac.za/zamaniProject_archive/index.php?showCollection="+sitePID;

	return false;
}

function appendFacetsAndPaginatedSearchResults(inputQuery){
		getAndAppendSearchResults(inputQuery, 0, false);

			$("body").css("cursor", "progress");
			//console.log("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q="+inputQuery+"&facet=true&facet.limit=10&facet.field=dc.type&facet.field=dc.format");
			$.get("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q="+inputQuery+"&facet=true&facet.limit=10&facet.field=dc.type&facet.field=dc.format",function(data,status){
				$("body").css("cursor", "default");
				var numPages = Math.min(Math.ceil(data.response.numFound / 10.0), 100);

				if(data.response.docs.length > 0){


					$('#documentStatus').html("<h5>Displaying <strong>1-"+ Math.min(10, data.response.numFound) + "</strong> of <strong>" + data.response.numFound + "</strong> results.</h5>");

					// Pagination
					$(function() {
						$("#pagination").pagination({
							pages: numPages,
							cssStyle: 'light-theme',
							onPageClick: function(pageNumber, event){
								var pageTo = parseInt(pageNumber*10);
								var pageStart = parseInt((pageNumber-1)*10) + 1;

								$('#documentStatus').html("<h5>Displaying <strong>" + pageStart + "-" + Math.min(pageTo, data.response.numFound) + "</strong> of <strong>" + data.response.numFound + "</strong> results.</h5>");

								getAndAppendSearchResults(inputQuery, (pageNumber-1)*10, false);
							}
						});
					});


					// Get Language, publisher, date Facet categories
					var languageFacets = '';
					var subjectFacets = '';

					var languageLength = Math.min(data.facet_counts.facet_fields['dc.type'].length, 10);
					for (var t=0; t< languageLength; t+=2){
						if (data.facet_counts.facet_fields['dc.type'][t+1] > 0) {
							languageFacets += "<li class='list-group-item'><label class='plain'><input type='checkbox' onClick='applyFilters(false)' value='dc.type:"+data.facet_counts.facet_fields['dc.type'][t]+"'> "+data.facet_counts.facet_fields['dc.type'][t]+ '</label><span class="badge">'+data.facet_counts.facet_fields['dc.type'][t+1]+'</span></li>';
						}
					}

					var subjectLength = Math.min(data.facet_counts.facet_fields['dc.format'].length, 10);
					for (var t=0; t< subjectLength; t+=2){
						if (data.facet_counts.facet_fields['dc.format'][t+1] > 0) {
							subjectFacets += "<li class='list-group-item'><label class='plain'><input type='checkbox' onClick='applyFilters(true)' value='dc.format:"+data.facet_counts.facet_fields['dc.format'][t]+"'> "+data.facet_counts.facet_fields['dc.format'][t]+ '</label><span class="badge">'+data.facet_counts.facet_fields['dc.format'][t+1]+'</span></li>';
						}
					}

					// FACET SIDEBAR
					$('#facet_content').html(

					"<div class='page-header'><h3>Refine search</h3></div>"+
					"<ul class='list-group'>"+
						"<li class='list-group-item' style='background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;'>Type</li>" +
						languageFacets +
					"</ul>"+
					"<ul class='list-group'>"+
						"<li class='list-group-item' style='background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;'>Date</li>" +
						"<li class='list-group-item-date-range'><form class='form-inline'><input id='startDate' class='form-control input-sm date-input' type='text' maxlength='4' size='5' placeholder='Year' style='width: 50px;'> to <input id='endDate' class='form-control input-sm date-input' type='text' maxlength='4' size='5' placeholder='Year' style='width: 50px;'><a id='dateRangeSubmit' class='btn btn-default btn-sm' style='float:right;'>Update</a></form><div id='rangeStatus'></div></li>" +
					"</ul>"+
					"<ul class='list-group' id='formatList'>"+
						"<li class='list-group-item' style='background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;'>Format</li>" +
						subjectFacets +
					"</ul>");

					$("#dateRangeSubmit").click(function(){

						//Ensure that startDate is in the correct format
						var filter = new RegExp("([1-2][0-9][0-9][0-9])");

						var startDateVal = $("#startDate").val();
						var endDateVal = $("#endDate").val();

						if(filter.test(startDateVal) && filter.test(endDateVal) && endDateVal > startDateVal){
							$("#rangeStatus").html('');
							// Use start and end Year to do a range query
							var dateRangeQuery = '&fq=dc.date:['+startDateVal+'-01-01T00:00:00Z'+' TO '+endDateVal+'-12-31T00:00:00Z'+']';
							getAndAppendSearchResults(getCurrentFilters()+dateRangeQuery, 0, true);
						}
						else{
							$("#rangeStatus").html('Invalid Date Range!');

						}

					});
				} else {
					$('#documentStatus').html('');
					$('#facet_content').html('');
				}

			});
}

// Get site collections on a query
// Append results into respective divs
function getSiteCollections(parentCollectionPID, id){
	//alert(parentCollectionPID);
	var query = "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/risearch.php?type=tuples&lang=itql&format=json&query=select%20%24member%20from%20%3C%23ri%3E%20where%20%24member%20%3Cfedora-rels-ext:isMemberOf%3E%20%3Cinfo:fedora/"+parentCollectionPID+"%3E";	

	var childrenCollectionsString = "";
	var siteDataArrayLength = 0;
	$.get(query, function(data,status){

		var siteDataArray = data.results;
		siteDataArrayLength  = siteDataArray.length;

		
		var countryArray = new Array();
		var siteNameArray = new Array();
		var latitudeArray = new Array();
		var longitudeArray = new Array();
		var idArray = new Array();
		var siteColPIDArray = new Array();
		//$('#search-title h3').html(childrenCollectionsString );
		//childrenCollectionsString = '<div class="page-header" id="search-title" style="display: block;"><h3>Search results</h3></div>';
		
		for (i=0;i<siteDataArray.length;i++)
		{
			var resultsTemp = "";

			var siteColFedoraObjectSplit = siteDataArray[i].member.split("/")[1].split(":");
			var siteColPID = siteColFedoraObjectSplit[0]+"\\:"+siteColFedoraObjectSplit[1];
			var siteColPIDNonFormatted = siteColFedoraObjectSplit[0]+":"+siteColFedoraObjectSplit[1];
			

			jQuery.ajax({
				url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?"+siteColPIDNonFormatted +"/datastreams/SITE/content",
				success: function(result) {
					
					var country = result.getElementsByTagName("country")[0].childNodes[0].nodeValue;
					var siteName = result.getElementsByTagName("name")[0].childNodes[0].nodeValue;
					var latitude = result.getElementsByTagName("latitude")[0].childNodes[0].nodeValue;
					var longitude = result.getElementsByTagName("longitude")[0].childNodes[0].nodeValue;

					countryArray.push(country);
					siteNameArray.push(siteName ); 
					latitudeArray.push(latitude ); 
					longitudeArray.push(longitude );
					idArray.push("collectionThumbnailBlock"+siteColPIDNonFormatted );  
					siteColPIDArray.push(siteColPIDNonFormatted);

					resultsTemp += '<div class="result-block" style="padding-bottom:8px; width: 102px;">';
					resultsTemp += '<div class="thumbnail-block" id="collectionThumbnailBlock'+siteColPIDNonFormatted +'"></div>';
					resultsTemp += '<a class="link" href="?showCollection='+siteColPIDNonFormatted+'"><strong>' + siteName + ' Collection</strong></a><br />';

					resultsTemp += '<br/></div>';	
					
					childrenCollectionsString += resultsTemp ;
				},
				async:   false
			});

		}

		//console.log("childrenCollectionsString"+childrenCollectionsString);
		//console.log($("#"+parentCollectionPID+"_content"));
		$(id).html(childrenCollectionsString);
		//document.getElementById(id).html(childrenCollectionsString);

		

		//return childrenCollectionsString;
	});
}



// Start Position refers to the position at which the documents to be queried should start from
function getAndAppendSearchResults(query, startPosition, faceted){

	//replace spaces with %20
	query = query.replace(/ /g,"%20");

	if (query != ''){
		$('#search-title').show();
		// Get search data
		$("body").css("cursor", "progress");
		//console.log("http://nala.cs.uct.ac.za/SERVER/solr.php?q="+query+"&start="+startPosition);
		console.log("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q="+query+"&start="+startPosition);
		$.get("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q="+query+"&start="+startPosition,function(data,status){
			$("body").css("cursor", "default");
			var searchResults = '';
			
			// Loop through each doc
			var documents = data.response.docs;

			var documentNumber = 0;
			var maxDocumentsPerPage = 10;
			maxDocumentsPerPage = Math.min(documents.length, 10);

			var longSearchResults = '';
			var resultsFound = true;

			var shortFormResult = '';
			var longFormResult = '';


			// Store the country Collections returned
			var countryCollectionArray = new Array();
			var countryCollectionsIDs = new Array();

			// Arrays for Site Collections (used for google map)
			var countryArray = new Array();
			var siteNameArray = new Array();
			var latitudeArray = new Array();
			var longitudeArray = new Array();
			var idArray = new Array();
			var siteColPIDArray = new Array();
			var countryCollectionCount = 0;
			if(documents.length > 0){
				jQuery.each( documents, function( i, val ) {
					documentNumber++;
					
					//http://nala.cs.uct.ac.za/SERVER/fedora/objects/uctnew:0000002/datastreams/FILE/content
					longFormResult = '';


					// Collection
					if (val['RELS_EXT_isCollection_literal_s']!=undefined){


						console.log((val['RELS_EXT_isCollection_literal_s']+''));
						console.log((val['RELS_EXT_isMemberOf_uri_s']+''));

						// Country Collection
						if ((val['RELS_EXT_isMemberOf_uri_s']+'')=="info:fedora/zamaniProjectCollection:1"){
							



	var query = "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/risearch.php?type=tuples&lang=itql&format=json&query=select%20%24member%20from%20%3C%23ri%3E%20where%20%24member%20%3Cfedora-rels-ext:isMemberOf%3E%20%3Cinfo:fedora/"+val['dc.identifier']+"%3E";	

	var childrenCollectionsString = "";
	var siteDataArrayLength = 0;
	$.get(query, function(data,status){

		var siteDataArray = data.results;
		siteDataArrayLength  = siteDataArray.length;
		collectionResult = '';

		//longFormResult += '<strong>Collection:  </strong> ' + (val['RELS_EXT_isCollection_literal_s']+'') + '<br />';
		collectionResult += '<div class="result-block" style="padding-bottom:8px; height: auto;">';
		collectionResult += '<div style="width:100%;"><a class="link" style="font-size: 16pt;" href="?showParentCollection='+val['dc.identifier']+'"><strong>' + val['dc.title'] + '</strong></a></div>';
							
		collectionResult += '<div id="col'+countryCollectionCount+'_content">';


		// Site Collections Arrays
		var countryArray = new Array();
		var siteNameArray = new Array();
		var latitudeArray = new Array();
		var longitudeArray = new Array();
		var idArray = new Array();
		var siteColPIDArray = new Array();


		// Country COllections Arrays
		var countryArray_country = new Array();
		var siteNameArray_country = new Array();
		var latitudeArray_country = new Array();
		var longitudeArray_country = new Array();
		var idArray_country = new Array();
		var siteColPIDArray_country = new Array();


		//$('#search-title h3').html(childrenCollectionsString );
		//childrenCollectionsString = '<div class="page-header" id="search-title" style="display: block;"><h3>Search results</h3></div>';
		
		for (i=0;i<siteDataArray.length;i++)
		{
			var resultsTemp = "";

			var siteColFedoraObjectSplit = siteDataArray[i].member.split("/")[1].split(":");
			var siteColPID = siteColFedoraObjectSplit[0]+"\\:"+siteColFedoraObjectSplit[1];
			var siteColPIDNonFormatted = siteColFedoraObjectSplit[0]+":"+siteColFedoraObjectSplit[1];
			

			jQuery.ajax({
				url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?"+siteColPIDNonFormatted +"/datastreams/SITE/content",
				success: function(result) {

					var resultsTemp = "";
					var country = result.getElementsByTagName("country")[0].childNodes[0].nodeValue;
					var siteName = result.getElementsByTagName("name")[0].childNodes[0].nodeValue;
					var latitude = result.getElementsByTagName("latitude")[0].childNodes[0].nodeValue;
					var longitude = result.getElementsByTagName("longitude")[0].childNodes[0].nodeValue;

					countryArray_country.push(country);
					siteNameArray_country.push(siteName ); 
					latitudeArray_country.push(latitude ); 
					longitudeArray_country.push(longitude );
					idArray_country.push("collectionThumbnailBlock"+siteColPIDNonFormatted );  
					siteColPIDArray_country.push(siteColPIDNonFormatted);

					resultsTemp += '<div class="result-block-collection" style="padding-bottom:8px; padding-top:5px; width: 102px; height: 200; float:left; margin-right:15px;">';
					resultsTemp += '<div class="thumbnail-block" id="collectionThumbnailBlock'+siteColPIDNonFormatted+'"></div>';
					resultsTemp += '<a class="link" href="?showCollection='+siteColPIDNonFormatted+'"><strong>' + siteName + ' Collection</strong></a><br />';

					resultsTemp += '<br/></div>';	
					
					childrenCollectionsString += resultsTemp ;
					
				},
				async:   false
			});

		}
		collectionResult += childrenCollectionsString;
		collectionResult += '</div>';
		collectionResult += '<br/><div class="clearfix"></div></div>';

		countryCollectionCount++;

 		$("#info_and_search_content").prepend(collectionResult);

		// Populate Country Collections sites with small google maps
		for (index = 0; index < countryArray_country.length; index++) {
			createCollectionMap(idArray_country[index], siteColPIDArray_country[index], latitudeArray_country[index], longitudeArray_country[index], siteNameArray_country[index]);
		}
	});




							//countryCollectionArray.push(val['dc.identifier']); 
							//countryCollectionsIDs.push('#col'+countryCollectionCount+'_content');
						}
						// Site Collection (member of a country collection)
						else{

							jQuery.ajax({
								url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?"+val['dc.identifier'] +"/datastreams/SITE/content",
								success: function(result) {
					
									var country = result.getElementsByTagName("country")[0].childNodes[0].nodeValue;
									var siteName = result.getElementsByTagName("name")[0].childNodes[0].nodeValue;
									var latitude = result.getElementsByTagName("latitude")[0].childNodes[0].nodeValue;
									var longitude = result.getElementsByTagName("longitude")[0].childNodes[0].nodeValue;

									countryArray.push(country);
									siteNameArray.push(siteName ); 
									latitudeArray.push(latitude ); 
									longitudeArray.push(longitude );
									idArray.push("collectionThumbnailBlock"+val['dc.identifier']);  
									siteColPIDArray.push(val['dc.identifier']);
					
									longFormResult += '<div class="result-block" style="padding-bottom:8px;">';
									longFormResult += '<div class="thumbnail-block" id="collectionThumbnailBlock'+val['dc.identifier']+'"></div>';
									longFormResult += '<div class="result-content-block">';
									longFormResult += '<a class="link" href="?showCollection='+val['dc.identifier']+'"><strong>' + siteName + ' Collection</strong></a><br />';
									longFormResult += '<strong>Collection:  </strong> ' + siteName + '<br />';
									longFormResult += '<strong>Country:  </strong> ' + country  + '<br />';
									longFormResult += '<strong>Latitude:  </strong> ' + latitude  + '<br />';
									longFormResult += '<strong>Longitude:  </strong> ' + longitude  + '<br />';
									longFormResult += '<br/><div class="clearfix"></div></div></div>';
								},
								async:   false
							});

						}

					}
					// File
					else{
						longFormResult += '<div class="result-block" style="padding-bottom:8px;">';
						longFormResult += '<div class="thumbnail-block" id="thumbnailBlock'+documentNumber+'"><img src="http://nala.cs.uct.ac.za/zamaniProject_archive/inc/getScaledImage.php?w=100&h=100&mimeType='+val['dc.format']+'&pid='+val['PID']+'"></div>';
						longFormResult += '<div class="result-content-block">';
						// synchronous Ajax GET
						//jQuery.ajax({
						//	 url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?"+val['PID']+''+"/datastreams/FILE/content",
						//	 success: function(result) {

						//		var sizeOfFile = result.getElementsByTagName("size")[0].childNodes[0].nodeValue;

								//var clientPathToFile = result.getElementsByTagName("client_path")[0].childNodes[0].nodeValue;
								//var serverPathToFile = result.getElementsByTagName("server_path")[0].childNodes[0].nodeValue;
								//console.log(sizeOfFile);
								//longFormResult += '<strong>Hmm:  </strong> ' + sizeOfFile + clientPathToFile + serverPathToFile + '<br />';
								
								var desc = val['dc.description'];
								if (desc==''){
									desc = 'Undefined';
								}

								var authorString = "";
								$.each( val['dc.creator'], function( index, value ){
									if (index==0){
										authorString += value;
									}
									else{
										authorString += "; "+value;
									}
    							
								});
								longFormResult += '<a class="link" href="?showMetadata='+escapedPID(val['dc.identifier'])+'"><strong>' + desc.trunc(100) + '</strong></a><br />';
								//longFormResult += '<strong>PID:  </strong> ' + (val['PID']+'') + '<br />';
								longFormResult += '<strong>Author:  </strong> ' + desc.trunc(mvPrint(authorString +'')) + '<br />';
								longFormResult += '<strong>Date:  </strong> ' + mvPrint(val['dc.date']+'') + '<br />';
								longFormResult += '<strong>Type:  </strong> ' + mvPrint(val['dc.type']+'') + '<br />';
								longFormResult += '<strong>Source:  </strong> ' + desc.trunc(mvPrint(val['dc.source']+'')) + '<br />';
								longFormResult += '<br/><div class="clearfix"></div></div></div>';
								//longFormResult += '<strong>Description:  </strong> ' + mvPrint(val['dc.description']+'') + '<br />';
						//	 },
						//	 async:   false
						//}); 
					}
					

						
					
					searchResults += longFormResult;
				});
			}else{
				resultsFound = false;
				searchResults += '<p>No results found.</p>';
				$("#pagination").pagination('destroy');
			}

			// wrap in div
			searchResults = '<div>' + searchResults + '</div>';
			$('#info_and_search_content').html(searchResults);

			

			// Populate Site Collection thumbnails with small google maps
			for (index = 0; index < countryArray.length; index++) {
				createCollectionMap(idArray[index], siteColPIDArray[index], latitudeArray[index], longitudeArray[index], siteNameArray[index]);
			}



		//for (index = 0; index < countryArray.length; index++) {
		//	createCollectionMap(idArray[index], siteColPIDArray[index], latitudeArray[index], longitudeArray[index], siteNameArray[index]);
		//}
			

			if (resultsFound){
				// If the user has faceted the query, re-paginate and getAndAppendSearchResults
				if (faceted){

					$('#documentStatus').html("<h5><strong> 1-"+ Math.min(10, data.response.numFound) + "</strong> of <strong>" + data.response.numFound + "</strong> results.</h5>");
					var numPages = Math.min(Math.ceil(data.response.numFound / 10.0), 100);

					$("#pagination").pagination('destroy');

					// Pagination
					$(function() {
						$("#pagination").pagination({
							pages: numPages,
							cssStyle: 'light-theme',
							onPageClick: function(pageNumber, event){
								var pageStart = parseInt((pageNumber-1)*10) + 1;
								var pageTo = parseInt(pageNumber*10);
								$('#documentStatus').html("<h5>Displaying <strong>" + pageStart + "-" + Math.min(pageTo, data.response.numFound) + "</strong> of <strong>" + data.response.numFound + "</strong> results.</h5>");

								getAndAppendSearchResults(query, (pageNumber-1)*10, false);
							}
						});
					});

				}
			}

		});
	}


	$('#map-canvas').hide();
	$('#searchByCollectionHeader').hide();
	$('#info_and_search_content').show();
	$('#pagination_content').show();
	$('#pagination').show();
	
	// Remove inline style from archive menu
	$('#archive-menu').removeAttr("style");	
}


function updateFormatFilter(inputQuery){
	$("body").css("cursor", "progress");
	$.get("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q="+inputQuery+"&facet=true&facet.limit=10&facet.field=dc.format",function(data,status){
		$("body").css("cursor", "default");
		
		if(data.response.docs.length > 0){

			// Get Language, publisher, date Facet categories
			var subjectFacets = '';

			var subjectLength = Math.min(data.facet_counts.facet_fields['dc.format'].length, 10);
			for (var t=0; t< subjectLength; t+=2){
				if (data.facet_counts.facet_fields['dc.format'][t+1] > 0) {
					subjectFacets += "<li class='list-group-item'><label class='plain'><input type='checkbox' onClick='applyFilters(true)' value='dc.format:"+data.facet_counts.facet_fields['dc.format'][t]+"'> "+data.facet_counts.facet_fields['dc.format'][t]+ '</label><span class="badge">'+data.facet_counts.facet_fields['dc.format'][t+1]+'</span></li>';
				}
			}

			// FACET SIDEBAR
			$('#formatList').html(
				"<li class='list-group-item' style='background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;'>Format</li>" +
				subjectFacets);
		} 
	});
}

function applyFilters(isFormatFilter) {
	var filters = {};
	var dcTypeIndex = -1;

	$.each(getSelectedFacets(), function( index, value ) {
		var filter = value.indexOf(':');
		var key = value.slice(0, filter);
		var val = value.slice(filter+1);

		if(filters[key] == null)
			filters[key] = [];
		
		if (!isFormatFilter){
			if(key=="dc.type"){
				filters[key].push(val);
			}
		}
		else{
			filters[key].push(val);
		}
		
	});

	

	var filterCount = 0;
	var facetString = '';
	$.each(filters, function(index, value){
		console.log(value.length);
		if (value.length>0){
			if (filterCount==0){
				facetString += '&fq=' + index + ':(';
			}
			else{
				facetString += ' AND ' + index + ':(';
			}
			
			for(var i=0; i < value.length; i++){
				if(i != 0){
					facetString += ' OR ';
				}	
				facetString += '"'+value[i]+'"';
			}
			facetString += ')';
			filterCount++;
		}
	});
	
	var queryString = "";

	if ($('#searchByTypeQuery').val()!=0){
		queryString = $('#searchByTypeQuery').val()+facetString;
	}
	else if ($('#selectedCollectionQuery').val()!=0){
		queryString = $('#selectedCollectionQuery').val()+facetString;
	}
	else{
		queryString = $('#autocomplete').val()+facetString;
	}
	//console.log($(queryString));
	// Check if there is a date range filter in play
	//-----------------------------------------------------------------
	//Ensure that startDate is in the correct format
	var filter = new RegExp("([1-2][0-9][0-9][0-9])");

	var startDateVal = $("#startDate").val();
	var endDateVal = $("#endDate").val();

	var dateRangeQuery = '';

	if(filter.test(startDateVal) && filter.test(endDateVal)){
		// Use start and end Year to do a range query
		dateRangeQuery = '&fq=dc.date:['+startDateVal+'-01-01T00:00:00Z'+' TO '+endDateVal+'-12-31T00:00:00Z'+']';
	}
	//-----------------------------------------------------------------
	console.log(queryString+dateRangeQuery);
	getAndAppendSearchResults(queryString+dateRangeQuery, 0, true);
	if (isFormatFilter==false){
		updateFormatFilter(queryString+dateRangeQuery);	
	}
}



function getCurrentFilters(){
	var filters = {};

	$.each(getSelectedFacets(), function( index, value ) {
		var filter = value.indexOf(':');
		var key = value.slice(0, filter);
		var val = value.slice(filter+1);

		if(filters[key] == null)
			filters[key] = [];

		filters[key].push(val);
	});

	var facetString = '';
	var filterCount = 0;
	$.each(filters, function(index, value){
		if (filterCount==0){
			facetString += '&fq=' + index + ':(';
		}
		else{
			facetString += ' AND ' + index + ':(';
		}
		for(var i=0; i < value.length; i++){
			if(i != 0){
				facetString += ' OR ';
			}	
			facetString += '"'+value[i]+'"';
		}
		facetString += ')';
		filterCount++;
	});
	if ($('#searchByTypeQuery').val()!=0){
		return $('#searchByTypeQuery').val()+facetString;
	}
	else if ($('#selectedCollectionQuery').val()!=0){
		return $('#selectedCollectionQuery').val()+facetString;
	}
	else{
		return $('#autocomplete').val()+facetString;
	}
}

function showCollection(collPID) {
	appendCollectionSearchTitle(collPID);
	var collPIDEscaped = escapedPID(collPID);
	var q = 'RELS_EXT_isMemberOf_uri_s:info\\:fedora/'+ collPIDEscaped;
	$('#selectedCollectionQuery').val(q);
	appendFacetsAndPaginatedSearchResults(q);

	return false;
}

function showChildrenCollections(parentCollectionPID){
	appendCollectionSearchTitle(parentCollectionPID);
	var query = "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/risearch.php?type=tuples&lang=itql&format=json&query=select%20%24member%20from%20%3C%23ri%3E%20where%20%24member%20%3Cfedora-rels-ext:isMemberOf%3E%20%3Cinfo:fedora/"+parentCollectionPID+"%3E";	
	console.log(query);

	var childrenCollectionsString = "";
	var siteDataArrayLength = 0;
	$.get(query, function(data,status){

		var siteDataArray = data.results;
		siteDataArrayLength  = siteDataArray.length;

		
		var countryArray = new Array();
		var siteNameArray = new Array();
		var latitudeArray = new Array();
		var longitudeArray = new Array();
		var idArray = new Array();
		var siteColPIDArray = new Array();
		//$('#search-title h3').html(childrenCollectionsString );
		//childrenCollectionsString = '<div class="page-header" id="search-title" style="display: block;"><h3>Search results</h3></div>';
		
		for (i=0;i<siteDataArray.length;i++)
		{
			var resultsTemp = "";

			var siteColFedoraObjectSplit = siteDataArray[i].member.split("/")[1].split(":");
			var siteColPID = siteColFedoraObjectSplit[0]+"\\:"+siteColFedoraObjectSplit[1];
			var siteColPIDNonFormatted = siteColFedoraObjectSplit[0]+":"+siteColFedoraObjectSplit[1];
			

			jQuery.ajax({
				url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?"+siteColPIDNonFormatted +"/datastreams/SITE/content",
				success: function(result) {
					
					var country = result.getElementsByTagName("country")[0].childNodes[0].nodeValue;
					var siteName = result.getElementsByTagName("name")[0].childNodes[0].nodeValue;
					var latitude = result.getElementsByTagName("latitude")[0].childNodes[0].nodeValue;
					var longitude = result.getElementsByTagName("longitude")[0].childNodes[0].nodeValue;

					countryArray.push(country);
					siteNameArray.push(siteName ); 
					latitudeArray.push(latitude ); 
					longitudeArray.push(longitude );
					idArray.push("collectionThumbnailBlock"+1);  
					siteColPIDArray.push(siteColPIDNonFormatted);

					//console.log(country );
					
					resultsTemp += '<div class="result-block" style="padding-bottom:8px;">';
					resultsTemp += '<div class="thumbnail-block" id="collectionThumbnailBlock'+1+'"></div>';
					resultsTemp += '<div class="result-content-block">';
					resultsTemp += '<a class="link" href="?showCollection='+siteColPIDNonFormatted+'"><strong>' + siteName + ' Collection</strong></a><br />';
					resultsTemp += '<strong>Collection:  </strong> ' + siteName + '<br />';
					resultsTemp += '<strong>Country:  </strong> ' + country  + '<br />';
					resultsTemp += '<strong>Latitude:  </strong> ' + latitude  + '<br />';
					resultsTemp += '<strong>Longitude:  </strong> ' + longitude  + '<br />';

					resultsTemp += '<br/><div class="clearfix"></div></div></div>';	
					
					childrenCollectionsString += resultsTemp ;
					console.log(resultsTemp);
				},
				async:   false
			});

		}

		$('#pagination').hide();
		$('#map-canvas').hide();
		$('#searchByCollectionHeader').hide();
		$('#info_and_search_content').html(childrenCollectionsString);

		$('#info_and_search_content').show();

		$('#search-title').show();
		$('#pagination_content').show();

		for (index = 0; index < countryArray.length; index++) {
			createCollectionMap(idArray[index], siteColPIDArray[index], latitudeArray[index], longitudeArray[index], siteNameArray[index]);
		}

	});

}

function appendCollectionSearchTitle(collectionID){
	var colPIDSplit = collectionID.split(":");
	var colPID = colPIDSplit[0]+"\\:"+colPIDSplit[1];

	jQuery.ajax({
		 url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q=PID:"+colPID+"&start=0",
		 success: function(result) {

			var documents = result.response.docs[0];
			var collectionTitle = mvPrint(documents['dc.title']+'');

			$("#search-title h3").html(collectionTitle);

		 },
		 async:   true
	});
}


function insertImage(clickedElement){

	var imageSrcID = clickedElement.id+"_value";
	
	var imageID = clickedElement.id+"_image";

	
	$("#imageViewer").html(
		'<header class="popupImage">'+
			'<img class="ImageBorder" id="'+imageID+'" src="'+$("#"+imageSrcID).val()+'">'+
		'</header>'
	);
}

$(document).ready(function(){

	// Hide search content and pagination
	$('#info_and_search_content').hide();
	$('#pagination_content').hide();

	// Show children collections of a collection
	var parentCollectionIdentifier = getQueryVariable("showParentCollection");
	if (parentCollectionIdentifier !=false){
		$('#searchByCollectionHeader').hide();
		showChildrenCollections(parentCollectionIdentifier);
		// Remove inline style from archive menu
		$('#archive-menu').removeAttr("style");		
	}

	// Show objects of a collection
	var collectionIdentifier = getQueryVariable("showCollection");
	if (collectionIdentifier!=false){
		$('#searchByCollectionHeader').hide();
		showCollection(collectionIdentifier);
		// Remove inline style from archive menu
		$('#archive-menu').removeAttr("style");	
	}

	// Show Refined Metadata for an object
	var objectIdentifier = getQueryVariable("showMetadata");
	if (objectIdentifier!=false){
		$('#pagination').hide();
		$('#map-canvas').hide();
		$('#searchByCollectionHeader').hide();
		$("#info_and_search_content").css("margin-top","0px");
		// Remove inline style from archive menu
		$('#archive-menu').removeAttr("style");	
		
		$.get("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q=PID:"+objectIdentifier+"&start=0",function(data,status){
			var searchResults = '';
			
			// Loop through each doc
			var documents = data.response.docs;
			var longFormResult = '';

			if(documents.length > 0){
				//$.get("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/getAdditionalMetadata.php?pid="+objectIdentifier,function(data,status){
					jQuery.each( documents, function( i, val ) {
						
						
 						//console.log(val);


						var desc = val['dc.description'];
						if (desc==''){
							desc = 'Undefined';
						}


						var objectIdentifierSplit = objectIdentifier.split("\\");
						objectIdentifier = objectIdentifierSplit[0] + objectIdentifierSplit[1];
						longFormResult = '';
						longFormResult += '<div class="result-block-large">';
						longFormResult +=  '<div><div style="float: left; font-size: 160%;font-family: Times New Roman, Times, serif;font-weight: normal;margin: 0 0 0.3em 0;padding: 0.3em; padding-bottom: 0px; width: 85%;">'+ desc +'</div><div id="request_container" style="float:right; display:none"><button class="btn btn-default btn-sm"  onclick="requestFile(\''+objectIdentifierSplit[0]+""+objectIdentifierSplit[1]+'\')">Request File</button><a id="requestModal_trigger" href="#requestModal"></a></div></div>';
						longFormResult +=  '<table class="table" style="margin-bottom:0px;"><tbody><tr><td><div class="thumbnail-block-large"><img src="http://nala.cs.uct.ac.za/zamaniProject_archive/inc/getScaledImage.php?w=200&h=200&mimeType='+val['dc.format']+'&pid='+objectIdentifier+'"></div><div style="width:100%"><input id="imageViewer_trigger_value" type="hidden" value="http://nala.cs.uct.ac.za/zamaniProject_archive/inc/getScaledImage.php?w=500&h=500&mimeType='+val['dc.format']+'&pid='+objectIdentifier+'"/><a class="link" id="imageViewer_trigger" href="#imageViewer" onclick="insertImage(this);"><span class="glyphicon glyphicon-zoom-in" style="margin-right:5px;"></span>View Larger Image</a></div></td>';
						longFormResult += '<td>';
					

						longFormResult += '<table class="table" style="margin-bottom:0px;" id="test" ><tbody id="metadataContent">';

						var authorString = "";
						$.each( val['dc.creator'], function( index, value ){
							if (index==0){
								authorString += value;
							}
							else{
								authorString += "; "+value;
							}
    							
						});

						var coverageSpatialString = "";
						$.each( val['dc.coverage'], function( index, value ){
							if (index==0){
								coverageSpatialString += value;
							}
							else{
								if (value!=""){
									coverageSpatialString += ", "+value;
								}
							}
    							
						});
						
						longFormResult += '<tr><th><strong>Author:  </strong></th><td>' + mvPrint(authorString +'') + '</td></tr>';
						longFormResult += '<tr><th><strong>Date:  </strong></th><td>' + mvPrint(val['dc.date']+'') + '</td></tr>';
						longFormResult += '<tr><th><strong>Type:  </strong></th><td>' + mvPrint(val['dc.type']+'') + '</td></tr>';
						longFormResult += '<tr><th><strong>Coverage: (Spatial)  </strong></th><td>' + mvPrint(coverageSpatialString +'') + '</td></tr>';
						longFormResult += '<tr><th><strong>Source:  </strong></th><td> ' + mvPrint(val['dc.source']+'') + '</td></tr>';
						longFormResult += '<tr><th><strong>Format:  </strong></th><td> ' + mvPrint(val['dc.format']+'') + '</td></tr>';
						
						// synchronous Ajax GET
						jQuery.ajax({
							 url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/getAdditionalMetadata.php?pid="+objectIdentifier,
							 success: function(result) {
								longFormResult += result;
							 },
							 async:   false
						}); 
						
						longFormResult += '</tbody></table>';	
						longFormResult += '<div class="clearfix"></div></td></tr></tbody></table></div>';	
				
						searchResults += longFormResult;
						$('#info_and_search_content').html(searchResults);

						var colPIDSplit = val['RELS_EXT_isMemberOf_uri_s'].split("/")[1].split(":");
						var colPID = colPIDSplit[0]+"\\:"+colPIDSplit[1];
					

						// synchronous Ajax GET
						jQuery.ajax({
							 url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q=PID:"+colPID+"&start=0",
							 success: function(result) {
								// Loop through each doc
								var documents = result.response.docs[0];
								var longFormResult = '';
								//console.log(documents['dc.title']);
								//console.log($('#metadataContent'));

								var parentColPIDSplit = documents['RELS_EXT_isMemberOf_uri_s'].split("/")[1].split(":");
								var parentColPID = parentColPIDSplit [0]+"\\:"+parentColPIDSplit [1];
								console.log(parentColPID );

								// synchronous Ajax GET
								jQuery.ajax({
									 url:    "http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q=PID:"+parentColPID +"&start=0",
							 		success: function(result) {
										var parentDocuments = result.response.docs[0];
										
										$("#test tbody").prepend('<tr><th><strong>Parent Collection:  </strong></th><td><a class="link" href="?showParentCollection='+parentDocuments ['dc.identifier']+'">' + mvPrint(parentDocuments ['dc.title']+'') + '</a></td></tr><tr><th><strong>Collection:  </strong></th><td><a class="link" href="?showCollection='+documents['dc.identifier']+'">' + mvPrint(documents['dc.title']+'') + '</a></td></tr>');
						 			
									},
									 async:   false
								});
							 },
							 async:   false

						});
						//$("#test tbody").prepend("<tr><td>...contents...</td></tr>");
						
						var dataString = {pid:objectIdentifierSplit[0]+""+objectIdentifierSplit[1]};
						jQuery.ajax({ 
							type:"POST",
							url:"inc/download/login_test.php",
							data: dataString, 
							success: function(data) {
								if(data.indexOf("false")==-1){
									
									$("#request_container").html(data);	
									$("#request_container").show();
								}
								else{
									
									$("#request_container").show();
								}
							}
						});

					});
				//});
			}else{
				searchResults += '<p>Metadata not found.</p>';
				$('#info_and_search_content').html(searchResults);
			}


			$('#info_and_search_content').show();
			$('#pagination_content').show();
			$("#imageViewer_trigger").leanModal({top : window.innerHeight/2, overlay : 0.8, closeButton: ".modal_close" });
			$("#requestModal_trigger").leanModal({top : 150, overlay : 0.6, closeButton: ".modal_close" });	
			//$('#imageViewer_trigger').click( function() { alert("dingus"); return false; } );
		});
		
	}

	$("#autocomplete").keyup(function(){
		//Get value of the entire input field
		var dInput = $(this).val();

		if(dInput == ""){
			$('#map-canvas').show();
			$('#searchByCollectionHeader').show();
			searchByTypeContent();
			$("#facet_content").empty();
			$("#pagination").pagination('destroy');
			$('#documentStatus').html("");
			$('#search-title').hide();
			$('#info_and_search_content').html("");
			$('#info_and_search_content').hide();
			$('#pagination_content').hide();			
		}
	});

	$('#autocomplete').autocomplete({
		serviceUrl: 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/suggest.php',
		onSelect: function (suggestion) {
		  $("#search_form").submit();
		},
		transformResult: function(response, originalQuery){
			
			var results = response.spellcheck.suggestions;
			var a = [];

			if(results.length > 0){
				var endIndex;
				var collation = ''

				if(results[results.length-2] == 'collation'){
					endIndex = results.length-2;
					collation = results[results.length-1];
				}else{
					endIndex = results.length;
				}

				for(var i=0; i < endIndex; i++){
					if(i%2 == 1){
						if(typeof results[i] != 'string'){
							for(var j=0; j < results[i].suggestion.length; j++){
								if(results[i].suggestion[j] != collation){
									a.push({value: results[i].suggestion[j], data: results[i].suggestion[j]});
								}
							}
						}
					}
				}
			}

			return {query: originalQuery, suggestions: a};
		},
		dataType: 'json'
	});

	$('#search_form').submit(function(event) {
		event.preventDefault();

		// Move the giraffe to the right
		if (parseInt($("#giraffe")[0].style.left)+4 <= 82){
			$('#giraffe').css('left', parseInt($("#giraffe")[0].style.left)+4+'%');
		}
		
		//get value of the entire input field
		var inputQuery = $('#autocomplete')[0].value;
		//set collection query to 0
		$('#selectedCollectionQuery').val(0);
		// Set search by type query to 0
		$('#searchByTypeQuery').val(0);

		//Set or reset search title 
		$("#search-title h3").html("Search Results");

		if (inputQuery != ''){
			appendFacetsAndPaginatedSearchResults(inputQuery);
		}
		return false;
	});
	
	
	
	// Create and Display 'Search by Type'
	if (collectionIdentifier==false){
		searchByTypeContent();
	}
	// Only display map on homepage
	if (collectionIdentifier==false && parentCollectionIdentifier==false && objectIdentifier==false){
		// Populate and Display Google Map
		populateAndInsertMap();
	}
});

function searchByTypeContent(){
	$("body").css("cursor", "progress");
	$.get("http://nala.cs.uct.ac.za/zamaniProject_archive/inc/solr.php?q=*:*&facet=true&facet.limit=10&facet.field=dc.type",function(data,status){
		$("body").css("cursor", "default");
		
		if(data.response.docs.length > 0){

			// Get Language, publisher, date Facet categories
			var subjectFacets = '';

			var subjectLength = Math.min(data.facet_counts.facet_fields['dc.type'].length, 10);
			for (var t=0; t< subjectLength; t+=2){
				if (data.facet_counts.facet_fields['dc.type'][t+1] > 0) {
					subjectFacets += "<li class='list-group-item'><label class='plain'><input type='checkbox' value='"+data.facet_counts.facet_fields['dc.type'][t]+"'> "+data.facet_counts.facet_fields['dc.type'][t]+ '</label><span class="badge">'+data.facet_counts.facet_fields['dc.type'][t+1]+'</span></li>';
				}
			}

			$('#facet_content').html(
				"<ul class='list-group'>"+
					"<li class='list-group-item' style='background-color: #FFBA02; border-color: #FFBA02; color: #000; font-weight: bold;'>Search By Type</li>" +
					subjectFacets +
					"<li class='list-group-item' style='height: 45px;'><a id='typeSearch' onClick='searchByType()' class='btn btn-default btn-sm' style='float:left;'>Search</a></li>" +
				"</ul>"
			);
		} 
	});
}

function searchByType(){	
	var queryString = '*:*&fq=dc.type:("';
	var count = 0;
	$.each(getSelectedFacets(), function( index, value ) {
		if (count==0){
			queryString += value + '"';
		}
		else{
			queryString += ' OR "' + value + '"';
		}
		count++;
	});
	queryString += ')';
	
	//Encode the query string
	queryString = encodeURI(queryString);
	
	$('#searchByTypeQuery').val(queryString);
	appendFacetsAndPaginatedSearchResults(queryString);	
}

function requestFile(requestQuery) {
	
	$("#request_string").val(requestQuery);
	
	console.log(requestQuery);
	
	$.ajax({ 
	url:"inc/download/login_test.php",
	success: function( data ) {
		if(data.indexOf("false")==-1){	
			$("#requestModal_trigger").click();	
		}
		else{
			 $("#modal_trigger").click();
		}
	}
	});
}



// Placeholder functions

function unsetPlaceholder(textarea){
	if (textarea.placeholder=='What can we help you find?'){textarea.placeholder='';return false;}
}

function setPlaceholder(textarea){
	if (textarea.placeholder==''){textarea.placeholder='What can we help you find?';return false;}
}
