<?php
if (isset($_GET['pid'])){
	$pid = $_GET['pid'];

	$additionalMetadataString = getFileSize($pid);
	$additionalMetadataString .= getPositions($pid);
	$additionalMetadataString .= getCalibrationSettings($pid);

	echo $additionalMetadataString;
}

function getFileSize($pid){
    $url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?'.$pid.'/datastreams/FILE/content';

    $ch = curl_init();  
 
    curl_setopt($ch,CURLOPT_URL,$url);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);

    $output=curl_exec($ch);
 
    //curl_close($ch);

    $deXml = simplexml_load_string($output);
    $deJson = json_encode($deXml);
    $xml_array = json_decode($deJson,TRUE);

    return  '<tr><th><strong>File Size:  </strong></th><td>'.$xml_array['size'].'</td></tr>';
}


function getPositions($pid){
    $url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?'.$pid.'/datastreams/POSITION/content';

    $ch = curl_init();  
 
    curl_setopt($ch,CURLOPT_URL,$url);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);

    $output=curl_exec($ch);
 
    curl_close($ch);

    $deXml = simplexml_load_string($output);
    $deJson = json_encode($deXml);
    $xml_array = json_decode($deJson,TRUE);
    //print_r($xml_array);


    $lat = $xml_array['latitude'];
    $latString = "undefined";

    if (!is_array($lat)){
	$latString = $xml_array['latitude'];
    }

    $long = $xml_array['langitude'];
    $longString = "undefined";

    if (!is_array($long)){
	$longString = $xml_array['langitude'];
    }

    $ellipse = $xml_array['ellipse'];
    $ellipseString = "undefined";

    if (!is_array($ellipse)){
	$ellipseString = $xml_array['ellipse'];
    }


    $positionString = '<div class="calibration"><ul><li><strong>Latitude: </strong>'.$latString.'</li>';
    $positionString .= '<li><strong>Longitude: </strong>'.$longString.'</li>';
    $positionString .= '<li><strong>Ellipse: </strong>'.$ellipseString.'</li></ul></div>';

    return  '<tr><th><strong>Position:  </strong></th><td>'.$positionString.'</td></tr>';

}
    


function getCalibrationSettings($pid){
    $url = 'http://nala.cs.uct.ac.za/zamaniProject_archive/inc/datastream.php?'.$pid.'/datastreams/CALIBRATION/content';

    $ch = curl_init();  
 
    curl_setopt($ch,CURLOPT_URL,$url);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);

    $output=curl_exec($ch);
 
    curl_close($ch);

    $deXml = simplexml_load_string($output);
    $deJson = json_encode($deXml);
    $xml_array = json_decode($deJson,TRUE);

    if(sizeof($xml_array)>1){
    
    	$calibrationString= '<ul><li><strong>Focal length: </strong><span class="calibration-padding">'.$xml_array['lengthFocal'].'</span></li>';
    	$calibrationString.= '<li><strong>Size: </strong><span class="calibration-padding">'.$xml_array['sizeX'].' x '.$xml_array['pixelSizeY'].'</span></li>';
    	$calibrationString.= '<li><strong>Pixel size: </strong><span class="calibration-padding">'.$xml_array['pixelSizeX'].' x '.$xml_array['pixelSizeY'].'</span></li>';
    	$calibrationString.= '<li><strong>Principal point: </strong><span class="calibration-padding">('.$xml_array['principalPointX'].', '.$xml_array['principalPointY'].')</span></li>';
    	$calibrationString.= '<li><strong>Decentering</strong>';
    	$calibrationString.= '<ul><li><strong>p1: </strong><span class="calibration-padding">'.$xml_array['decenteringP1'].'</span></li>';
    	$calibrationString.= '<li><strong>p2: </strong><span class="calibration-padding">'.$xml_array['decenteringP2'].'</span></li></ul></li>';
    	$calibrationString.= '<li><strong>Radial distortion</strong>';
    	$calibrationString.= '<ul><li><strong>k1: </strong><span class="calibration-padding">'.$xml_array['distortionRadialK1'].'</span></li>';
    	$calibrationString.= '<li><strong>k2: </strong><span class="calibration-padding">'.$xml_array['distortionRadialK2'].'</span></li>';
    	$calibrationString.= '<li><strong>k3: </strong><span class="calibration-padding">'.$xml_array['distortionRadialK3'].'</span></li></ul></li>';
   	$calibrationString.= '<li><strong>Affine distortion</strong>';
   	$calibrationString.= '<ul><li><strong>b1: </strong><span class="calibration-padding">'.$xml_array['distortionAffineB1'].'</span></li>';
   	$calibrationString.= '<li><strong>b2: </strong><span class="calibration-padding">'.$xml_array['distortionAffineB2'].'</span></li></ul></li>';

     

    	$finalCalibrationString = '<tr><th><strong>Calibration Date: </strong></th><td>'.$xml_array['date'].'</td></tr>';
    	$finalCalibrationString .= '<tr><th><strong>Camera Model: </strong></th><td>'.$xml_array['camera'].'</td></tr>';
    	$finalCalibrationString .= '<tr><th><strong>Calibration Settings:  </strong></th><td class="calibration">'.$calibrationString.'</td></tr>';

    	return $finalCalibrationString;
    }
    else{
        return "";
    }
}
?>